Name:           i3
Version:        4.18.2
Release:        2%{?dist}
Epoch:          1000
Summary:        Improved tiling window manager
License:        BSD
URL:            https://i3wm.org
Source0:        %{URL}/downloads/%{name}-%{version}.tar.bz2
Source1:        %{name}-logo.svg
Patch0:         0001-Show-qubes-domain-in-configurable-colored-borders.patch

BuildRequires:  gcc
BuildRequires:  autoconf
BuildRequires:  automake
# from configure.ac and DEPENDS (mostly versions)
BuildRequires:  pkgconfig >= 0.25
# no pkg-config for libev
BuildRequires:  libev-devel >= 4.0
BuildRequires:  pkgconfig(libstartup-notification-1.0)
BuildRequires:  pkgconfig(xcb) >= 1.1.93
BuildRequires:  pkgconfig(xcb-xkb)
BuildRequires:  pkgconfig(xcb-xinerama)
BuildRequires:  pkgconfig(xcb-randr)
BuildRequires:  pkgconfig(xcb-shape)
BuildRequires:  pkgconfig(xcb-event)
BuildRequires:  pkgconfig(xcb-util)
BuildRequires:  pkgconfig(xcb-cursor)
BuildRequires:  pkgconfig(xcb-keysyms)
BuildRequires:  pkgconfig(xcb-icccm)
BuildRequires:  pkgconfig(xcb-xrm)
BuildRequires:  pkgconfig(xkbcommon) >= 0.4.0
BuildRequires:  pkgconfig(xkbcommon-x11) >= 0.4.0
BuildRequires:  pkgconfig(yajl) >= 2.0.1
BuildRequires:  pkgconfig(libpcre) >= 8.10
BuildRequires:  pkgconfig(cairo) >= 1.14.4
BuildRequires:  pkgconfig(pangocairo) >= 1.30.0
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(gobject-2.0)
# man pages
BuildRequires:  asciidoc >= 8.3.0
BuildRequires:  xmlto >= 0.0.23

# TODO: Testsuites
# BuildRequires:  perl(ExtUtils::MakeMaker)
#BuildRequires:  perl(strict)
#BuildRequires:  perl(warnings)
#BuildRequires:  perl(Pod::Usage)
#BuildRequires:  perl(Cwd)
#BuildRequires:  perl(File::Temp)
#BuildRequires:  perl(Getopt::Long)
#BuildRequires:  perl(POSIX)
#BuildRequires:  perl(TAP::Harness)
#BuildRequires:  perl(TAP::Parser)
#BuildRequires:  perl(TAP::Parser::Aggregator)
#BuildRequires:  perl(Time::HiRes)
#BuildRequires:  perl(IO::Handle)
#BuildRequires:  perl(AnyEvent::Util)
#BuildRequires:  perl(AnyEvent::Handle)
#BuildRequires:  perl(AnyEvent::I3)
#BuildRequires:  perl(X11::XCB::Connection)
#BuildRequires:  perl(Carp)

BuildRequires:  perl-generators
BuildRequires:  perl(Pod::Simple)
%ifnarch s390 s390x
BuildRequires:  xorg-x11-drv-dummy
%endif

Requires: qubes-desktop-linux-common

Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%{!?rhel:Recommends:     rxvt-unicode}
%{!?rhel:Recommends:     xorg-x11-apps}
Requires:       xorg-x11-fonts-misc
# for i3-save-tree
Requires:       perl(AnyEvent::I3) >= 0.12

%if 0%{?rhel} != 7
Recommends:     pulseaudio-utils
Recommends:     dmenu
Recommends:     i3status
Recommends:     i3lock
%endif

%description
Key features of i3 are correct implementation of XrandR, horizontal and vertical
columns (think of a table) in tiling. Also, special focus is on writing clean,
readable and well documented code. i3 uses xcb for asynchronous communication
with X11, and has several measures to be very fast.

Please be aware that i3 is primarily targeted at advanced users and developers.

%package        doc
Summary:        Documentation for %{name}
BuildArch:      noarch
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    doc
Asciidoc generated documentation for %{name}.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    devel
Header files for %{name}.

%package        devel-doc
Summary:        Documentation for the development files of %{name}
BuildRequires:  doxygen
BuildArch:      noarch
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    devel-doc
Doxygen generated documentations for %{name}.

%prep
%autosetup -p1

# Drop /usr/bin/env lines in those which will be installed to %%_bindir.
find . -maxdepth 1 -type f -name "i3*" -exec sed -i -e '1s;^#!/usr/bin/env perl;#!/usr/bin/perl;' {} + -print


%build
mkdir build && pushd build
ln -s ../configure configure
%configure
%make_build
popd

doxygen pseudo-doc.doxygen
mv pseudo-doc/html pseudo-doc/doxygen

%install
pushd build
%make_install

mkdir -p %{buildroot}%{_mandir}/man1/
install -Dpm0644 man/*.1 \
        %{buildroot}%{_mandir}/man1/

mkdir -p %{buildroot}%{_datadir}/pixmaps/
install -Dpm0644 %{SOURCE1} \
        %{buildroot}%{_datadir}/pixmaps/

%check
%ifnarch s390 s390x
# TODO: with xorg dummy to test the package.
# TODO: get remaining dependencies in
# make check
%endif

%files
%doc RELEASE-NOTES-%{version}
%license LICENSE
%{_bindir}/%{name}*
%dir %{_sysconfdir}/%{name}/
%config(noreplace) %{_sysconfdir}/%{name}/config
%config(noreplace) %{_sysconfdir}/%{name}/config.keycodes
%{_datadir}/xsessions/%{name}.desktop
%{_datadir}/xsessions/%{name}-with-shmlog.desktop
%{_mandir}/man*/%{name}*
%{_datadir}/pixmaps/%{name}-logo.svg
%{_datadir}/applications/%{name}.desktop
%exclude %{_docdir}/%{name}/

%files doc
%license LICENSE
%doc docs/*.{html,png}

%files devel
%license LICENSE
%{_includedir}/%{name}/

%files devel-doc
%license LICENSE
%doc pseudo-doc/doxygen/

%changelog
* Fri Aug 07 2020 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-desktop-linux-i3.git

* Fri Aug 07 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8f4ee22
- version 4.18.2-2

* Wed Aug 05 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 9f3a1dc
- spec: don't fails with CentOS 7 due to older rpm

* Wed Aug 05 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 40d77ab
- Remove useless/missing deps

* Tue Aug 04 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 3cf4f3e
- Update to 4.18.2

* Mon May 04 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - f103464
- Cleanup repo and update README

* Wed Apr 15 2020 w1k1n9cc <git@malbolge.de> - 67b4144
- Wrong package name for pkgconfig in spec file

* Mon Apr 06 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - eb0aa08
- Update Makefile and version to i3-4.18

* Fri Jan 24 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5799e71
- version 4.17.1-2

* Sun Jan 19 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - f658f24
- travis: drop dom0 Fedora 25

* Sun Jan 19 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 26a40af
- spec: sync with upstream

* Sat Jan 11 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 86d1188
- travis: switch to dom0 Fedora 31

* Sat Oct 19 2019 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 00befe6
- travis: switch to bionic

* Wed Sep 18 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f30ffda
- travis: add R4.1 build, ignore irrelevant branches/tags

* Tue Sep 17 2019 anadahz <andz@torproject.org> - 0487871
- Update Travis dist to Ubuntu Xenial

* Mon Sep 16 2019 anadahz <andz@torproject.org> - f8a81b8
- Update i3 package to upstream version 4.17.1

* Fri Aug 02 2019 Daniel Moerner <dmoerner@gmail.com> - 00d1890
- Restore old changelog entry in spec

* Tue Jul 23 2019 Daniel Moerner <dmoerner@gmail.com> - 31d40c1
- Only expand title to qubes name if container is non-empty.

* Sun Jul 21 2019 Daniel Moerner <dmoerner@gmail.com> - 3cd1621
- Update i3 to 4.16.1

* Wed Apr 17 2019 FireGrace <legendaryevryday@gmail.com> - 6c8db55
-         Qube-colors update basing on spec

* Sun Jan 27 2019 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 08ed9f8
- Move i3-settings-qubes as a separate repository

* Sat Nov 17 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2f7dc92
- travis: remove explicit wget

* Sat Nov 17 2018 anadahz <andz@torproject.org> - d969ed5
- Update to i3-4.16

* Wed Apr 04 2018 anadahz <andz@torproject.org> - 80c2cc7
- Update to i3-4.15

* Tue Apr 03 2018 anadahz <andz@torproject.org> - 0de69c5
- Fix source hashes

* Tue Feb 27 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1495409
- i3-settings-qubes 1.5

* Tue Feb 13 2018 qavenull <qavenull@outlook.com> - d770212
- Floating Tor Browser as a default

* Mon Feb 12 2018 yeoldegrove (git) <git@yeoldegrove.de> - 4b3c41f
- no xargs, better regex, fix typo

* Mon Feb 12 2018 yeoldegrove (git) <git@yeoldegrove.de> - 38ef78c
- added --no-spinner

* Mon Feb 12 2018 yeoldegrove (git) <git@yeoldegrove.de> - 6598ac1
- changed to list of netvms instead of count

* Sat Jan 13 2018 yeoldegrove <git@yeoldegrove.de> - 31265d2
- fix number of netvms and qubes

* Tue Dec 05 2017 Jean-Philippe Ouellet <jpo@vt.edu> - ce7c4ad
- http -> https

* Sun Sep 24 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a221ca7
- i3-settings-qubes 1.4

* Sat Sep 23 2017 Sean Hunter <sean@uncarved.com> - bfe6986
- Fix deps so dmenu should work. This should fix https://github.com/QubesOS/qubes-issues/issues/3091

* Sat Sep 23 2017 Sean Hunter <sean@uncarved.com> - a5c3364
- fix source hashes

* Sat Sep 23 2017 Sean Hunter <sean@uncarved.com> - b998cf7
- Fix build deps and build instructions

* Thu Jul 06 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3b02f80
- i3 4.12-6, i3-settings-qubes 1.3

* Thu Jul 06 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5e9c9a5
- travis: update for Qubes 4.0

* Fri Mar 31 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 3455067
- Require qubes-desktop-linux-common

* Sun Feb 26 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 03e55e1
- Fix handling user autostarts

* Tue Feb 14 2017 Daniel Moerner <dmoerner@gmail.com> - 8184164
- Prefer terminals that distinguish dom0 from qubes

* Mon Feb 13 2017 Daniel Moerner <dmoerner@gmail.com> - 37083f0
- Clean up i3.config comments and code

* Mon Nov 28 2016 Dhole <dhole@openmailbox.org> - 51caad2
- Enable editable configuration of qubes windows colors

* Sat Aug 06 2016 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a5b3012
- i3 4.12-5, i3-settings-qubes 1.2

* Wed Jul 20 2016 Daniel Mendler <mail@daniel-mendler.de> - fe877e0
- update sensible terminal

* Wed Jul 20 2016 Daniel Mendler <mail@daniel-mendler.de> - ea64dd9
- use qubes colors for window borders

* Sun Jun 26 2016 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c7de118
- travis: drop R3.1 test

* Sun Jun 26 2016 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 566bb66
- travis: download source tarball manually

* Sun Jun 26 2016 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 990c1e2
- i3 4.12-4

* Sun Jun 26 2016 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 82621f1
- Update source hash for 4.12

* Tue Jun 21 2016 Daniel Mendler <mail@daniel-mendler.de> - 1357549
- update to i3-4.12

